# Class Table

A class representing database tables and their properties.

Use this to create or delete tables and their properties, or to query or change table rows.

To query, update, insert or delete rows in an existing table, first you should find the table object with findOne.

#### Example

    Table.findOne({name: "Customers"}) // find the table with name "Customers"
    Table.findOne("Customers") // find the table with name "Customers" (shortcut)
    Table.findOne({ id: 5 }) // find the table with id=5
    Table.findOne(5) // find the table with id=5 (shortcut)

Table.findOne is synchronous (no need to await), But the functions that query and manipulate (such as insertRow, getRows, updateRow, deleteRows) rows are mostly asyncronous, so you can put the await in front of the whole expression

#### Example

To count the number of rows in the customer table

    const nrows = await Table.findOne("Customers").countRows()

For further examples, see the Table test suite

## Querying table rows

There are several methods you can use to retrieve rows in the database:

- countRows To count the number of rows, optionally matching a criterion
- getRows To retrieve multiple rows matching a criterion
- getRow To retrieve a single row matching a criterion
- getJoinedRows To retrieve rows together with joinfields and aggregations

These functions all take `Where` expressions which are JavaScript objects describing the criterion to match to. Some examples:

- `{}`: Match all rows
- `{ name: "Jim" }`: Match all rows with name="Jim"
- `{ name: { ilike: "im"} }`: Match all rows where name contains "im" (case insensitive)
- `{ name: /im/ }`: Match all rows with name matching regular expression "im"
- `{ age: { lt: 18 } }`: Match all rows with age<18
- `{ age: { lt: 18, equal: true } }`: Match all rows with age<=18
- `{ age: { gt: 18, lt: 65} }`: Match all rows with 18<age<65
- `{ name: { or: ["Harry", "Sally"] } }`: Match all rows with name="Harry" or "Sally"
- `{ or: [{ name: "Joe"}, { age: 37 }] }`: Match all rows with name="Joe" or age=37
- `{ not: { id: 5 } }`: All rows except id=5
- `{ id: { in: [1, 2, 3] } }`: Rows with id 1, 2, or 3
- `{ id: { not: { in: [1, 2, 3] } } }`: Rows with id any value except 1, 2, or 3

For further examples, see the mkWhere test suite

## Updating a Row

There are two nearly identical functions for updating rows depending on how you want failures treated

- updateRow Update a row, throws an exception if update is invalid
- tryUpdateRow Update a row, return an error message if update is invalid

## Inserting a new Row

There are two nearly identical functions for inserting a new row depending on how you want failures treated

- insertRow insert a row, throws an exception if it is invalid
- tryInsertRow insert a row, return an error message if it is invalid

## Deleting rows

Use deleteRows to delete any number (zero, one or many) of rows matching a criterion. It uses the same `where` expression as the functions for querying rows

#### Hierarchy

- Table

#### Implements

- AbstractTable

- Defined in saltcorn-data/models/table.ts:220
- Defined in saltcorn-data/models/table.ts:4258

#####
Index

### Constructors

constructor

### Properties

constraints
description?
external
fields
has_sync_info
id?
is_user_group
min_role_read
min_role_write
name
ownership_field_id?
ownership_formula?
provider_cfg?
provider_name?
versioned

### Accessors

pk_name
pk_type
santized_name
sql_name
to_json

### Methods

aggregationQuery
check_table_constraints
compress_history
countRows
delete
deleteRows
distinctValues
dump_history_to_json
dump_to_json
enable_fkey_constraints
field_options
getField
getFields
getForeignKeys
getForeignTables
getFormulaExamples
getJoinedQuery
getJoinedRow
getJoinedRows
getRow
getRows
getTags
get_child_relations
get_history
get_join_field_options
get_models
get_parent_relations
get_relation_data
get_relation_options
import_csv_file
import_json_file
import_json_history_file
insertRow
insert_history_row
is_owner
latestSyncInfo
latestSyncInfos
move_include_fts_to_search_context
normalise_error_message
normalise_fkey_values
owner_fieldname
owner_fieldname_from_fields
ownership_formula_where
ownership_options
parse_json_fields
processSelectOptions
read_state_strict
redo_row_changes
rename
repairCompositePrimary
resetSequence
restore_row_version
slug_options
stringify_json_fields
to_provided_table
toggleBool
tryInsertRow
tryUpdateRow
undo_row_changes
update
updateRow
allSlugOptions
create
createInDb
create_from_csv
find
findOne
find_with_external
state_refresh

## Constructors

### constructor

- new Table(o): Table

- Table constructor

  #### Parameters

  - ##### o: TableCfg

  #### Returns Table

  - Defined in saltcorn-data/models/table.ts:270

## Properties

### constraints

constraints: TableConstraint[]

An array of TableConstraints for this table

- Defined in saltcorn-data/models/table.ts:256

### `Optional` description

description?: string

A description of the purpose of the table

- Defined in saltcorn-data/models/table.ts:250

### external

external: boolean

If true this is an external table (not a database table)

- Defined in saltcorn-data/models/table.ts:247

### fields

fields: Field[]

An array of Fields in this table

Implementation of AbstractTable.fields

- Defined in saltcorn-data/models/table.ts:253

### has_sync_info

has_sync_info: boolean

Whether sync info for mobile apps is enabled for this table

- Defined in saltcorn-data/models/table.ts:244

### `Optional` id

id?: number

The table ID

Implementation of AbstractTable.id

- Defined in saltcorn-data/models/table.ts:225

### is_user_group

is_user_group: boolean

Is this a user group? If yes it will appear as options in the ownership dropdown

- Defined in saltcorn-data/models/table.ts:259

### min_role_read

min_role_read: number

Minimum role to read

Implementation of AbstractTable.min_role_read

- Defined in saltcorn-data/models/table.ts:228

### min_role_write

min_role_write: number

Minimum role to write

Implementation of AbstractTable.min_role_write

- Defined in saltcorn-data/models/table.ts:231

### name

name: string

The table name

Implementation of AbstractTable.name

- Defined in saltcorn-data/models/table.ts:222

### `Optional` ownership_field_id

ownership_field_id?: null | number

The ID of the ownership field

Implementation of AbstractTable.ownership_field_id

- Defined in saltcorn-data/models/table.ts:234

### `Optional` ownership_formula

ownership_formula?: string

A formula to denote ownership. This is a JavaScript expression which must evaluate to true if the user is the owner

Implementation of AbstractTable.ownership_formula

- Defined in saltcorn-data/models/table.ts:238

### `Optional` provider_cfg

provider_cfg?: Row

Configuration for the table provider for this table

- Defined in saltcorn-data/models/table.ts:265

### `Optional` provider_name

provider_name?: string

Name of the table provider for this table (not a database table)

- Defined in saltcorn-data/models/table.ts:262

### versioned

versioned: boolean

Version history enabled for this table

- Defined in saltcorn-data/models/table.ts:241

## Accessors

### pk_name

- get pk_name(): string

- Get primary key field name

  #### Returns string

  - Defined in saltcorn-data/models/table.ts:1818

### pk_type

- get pk_type(): Type

- #### Returns Type

  - Defined in saltcorn-data/models/table.ts:1826

### santized_name

- get santized_name(): string

- get sanitized name of table

  #### Returns string

  - Defined in saltcorn-data/models/table.ts:664

### sql_name

- get sql_name(): string

- Get Table SQL Name

  #### Returns string

  Implementation of AbstractTable.sql_name

  - Defined in saltcorn-data/models/table.ts:861

### to_json

- get to_json(): {
  external: boolean;
  fields: any[];
  id: undefined | number;
  min_role_read: number;
  min_role_write: number;
  name: string;
  ownership_field_id: undefined | null | number;
  ownership_formula: undefined | string;
  provider_cfg: undefined | Row;
  provider_name: undefined | string;
  versioned: boolean;
  }

- #### Returns {
  external: boolean;
  fields: any[];
  id: undefined | number;
  min_role_read: number;
  min_role_write: number;
  name: string;
  ownership_field_id: undefined | null | number;
  ownership_formula: undefined | string;
  provider_cfg: undefined | Row;
  provider_name: undefined | string;
  versioned: boolean;
  }

  - ##### external: boolean

  - ##### fields: any[]

  - ##### id: undefined | number

  - ##### min_role_read: number

  - ##### min_role_write: number

  - ##### name: string

  - ##### ownership_field_id: undefined | null | number

  - ##### ownership_formula: undefined | string

  - ##### provider_cfg: undefined | Row

  - ##### provider_name: undefined | string

  - ##### versioned: boolean

  - Defined in saltcorn-data/models/table.ts:289

## Methods

### aggregationQuery

- aggregationQuery(aggregations, options?): Promise<Row>

- Returns aggregations for this table, possibly on a subset by where-expression

  #### Parameters

  - ##### aggregations: {
    [nm: string]: {
    aggregate: string;
    field?: string;
    valueFormula?: string;
    };
    }

    - ##### [nm: string]: {
      aggregate: string;
      field?: string;
      valueFormula?: string;
      }

      - ##### aggregate: string

      - ##### `Optional` field?: string

      - ##### `Optional` valueFormula?: string

  - ##### `Optional` options: {
    groupBy?: string | string[];
    where?: Where;
    }

    - ##### `Optional` groupBy?: string | string[]

    - ##### `Optional` where?: Where

  #### Returns Promise<Row>

  - Defined in saltcorn-data/models/table.ts:3632

### check_table_constraints

- check_table_constraints(row0): undefined | string

- Check table constraints against a row object. Will return a string With an error message if the table constraints are violated, `undefined` if the row does not violate any constraints

  #### Parameters

  - ##### row0: Row

  #### Returns undefined | string

  - Defined in saltcorn-data/models/table.ts:1846

### compress_history

- compress_history(options): Promise<void>

- Compress history by minimal interval and/or deleting unchanged rows. Can be called with options object, or just minimal interval for legacy code

  #### Parameters

  - ##### options: number | {
    delete_unchanged?: boolean;
    interval_secs?: number;
    }

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:2595

### countRows

- countRows(where?, opts?): Promise<number>

- Count the number of rows in db table. The argument is a where-expression with conditions the counted rows should match. countRows returns the number of matching rows wrapped in a promise.

  #### Parameters

  - ##### `Optional` where: Where

  - ##### `Optional` opts: ForUserRequest

  #### Returns Promise<number>

  #### Example

      const bookTable = Table.findOne({name: "books"})

      // Count the total number of rows in the books table
      const totalNumberOfBooks = await bookTable.countRows({})

      // Count the number of books where the cover_color field has the value is "Red"
      const numberOfRedBooks = await bookTable.countRows({cover_color: "Red"})

      // Count number of books with more than 500 pages
      const numberOfLongBooks = await bookTable.countRows({pages: {gt: 500}})

  - Defined in saltcorn-data/models/table.ts:1281

### delete

- delete(only_forget?): Promise<void>

- Drop current table

  #### Parameters

  - ##### only_forget: boolean = false

    boolean - if true that only

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:829

### deleteRows

- deleteRows(where, user?, noTrigger?): Promise<void>

- Delete rows from table. The first argument is a where expression indicating the conditions for the rows to be deleted

  #### Parameters

  - ##### where: Where

    condition

  - ##### `Optional` user: AbstractUser

    optional user, if null then no authorization will be checked

  - ##### `Optional` noTrigger: boolean

  #### Returns Promise<void>

  #### Example

      // delete all books where author = "Friedrich Nietzsche"
      await Table.findOne({name: "books"}).deleteRows({author: "Friedrich Nietzsche"})

  - Defined in saltcorn-data/models/table.ts:979

### distinctValues

- distinctValues(fieldnm, whereObj?): Promise<any[]>

- Return distinct Values for column in table ????

  #### Parameters

  - ##### fieldnm: string

  - ##### `Optional` whereObj: Where

  #### Returns Promise<any[]>

  - Defined in saltcorn-data/models/table.ts:1291

### dump_history_to_json

- dump_history_to_json(filePath): Promise<void>

- #### Parameters

  - ##### filePath: string

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:2920

### dump_to_json

- dump_to_json(filePath): Promise<void>

- #### Parameters

  - ##### filePath: string

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:2912

### enable_fkey_constraints

- enable_fkey_constraints(): Promise<void>

- Enable constraints

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:2746

### field_options

- field_options(nrecurse?, fieldWhere?, prefix?): Promise<string[]>

- #### Parameters

  - ##### nrecurse: number = 0

  - ##### fieldWhere: ((f) => boolean) = ...

    - - (f): boolean

      - #### Parameters

        - ##### f: Field

        #### Returns boolean

  - ##### prefix: string = ""

  #### Returns Promise<string[]>

  - Defined in saltcorn-data/models/table.ts:3560

### getField

- getField(path): undefined | Field

- Get a field, possibly by relation

  #### Parameters

  - ##### path: string

  #### Returns undefined | Field

  - Defined in saltcorn-data/models/table.ts:2388

### getFields

- getFields(): Field[]

- Get Fields list for table

  #### Returns Field[]

  - Defined in saltcorn-data/models/table.ts:2372

### getForeignKeys

- getForeignKeys(): Field[]

- get foreign keys, without the 'File' type

  #### Returns Field[]

  array of FK Fields

  - Defined in saltcorn-data/models/table.ts:2380

### getForeignTables

- getForeignTables(): Promise<AbstractTable[]>

- #### Returns Promise<AbstractTable[]>

  Implementation of AbstractTable.getForeignTables

  - Defined in saltcorn-data/models/table.ts:4123

### getFormulaExamples

- getFormulaExamples(typename): string[]

- #### Parameters

  - ##### typename: string

  #### Returns string[]

  - Defined in saltcorn-data/models/table.ts:4136

### getJoinedQuery

- getJoinedQuery(opts?): Promise<Partial<JoinOptions> & {
  notAuthorized?: boolean;
  sql?: string;
  values?: Value[];
  }>

- #### Parameters

  - ##### opts: any = {}

  #### Returns Promise<Partial<JoinOptions> & {
  notAuthorized?: boolean;
  sql?: string;
  values?: Value[];
  }>

  - Defined in saltcorn-data/models/table.ts:3747

### getJoinedRow

- getJoinedRow(opts?): Promise<null | Row>

- #### Parameters

  - ##### `Optional` opts: any = {}

  #### Returns Promise<null | Row>

  - Defined in saltcorn-data/models/table.ts:3919

### getJoinedRows

- getJoinedRows(opts?): Promise<Row[]>

- Get rows along with joined and aggregated fields. The argument to `getJoinedRows` is an object with several different possible fields, all of which are optional

  - `where`: A Where expression indicating the criterion to match
  - `joinFields`: An object with the joinfields to retrieve
  - `aggregations`: An object with the aggregations to retrieve
  - `orderBy`: A string with the name of the field to order by
  - `orderDesc`: If true, descending order
  - `limit`: A number with the maximum number of rows to retrieve
  - `offset`: The number of rows to skip in the result before returning rows

  #### Parameters

  - ##### `Optional` opts: any = {}

  #### Returns Promise<Row[]>

  #### Example

      const patients = Table.findOne({ name: "patients" });
      const patients_rows = await patients.getJoinedRows({
           where: { age: { gt: 65 } },
           orderBy: "id",
           aggregations: {
             avg_temp: {
               table: "readings",
               ref: "patient_id",
               field: "temperature",
               aggregate: "avg",
            },
           },
           joinFields: {
             pages: { ref: "favbook", target: "pages" },
             author: { ref: "favbook", target: "author" },
           },
      });

  - Defined in saltcorn-data/models/table.ts:3962

### getRow

- getRow(where?, selopts?): Promise<null | Row>

- Get one row from the table in the database. The matching row will be returned in a promise - use await to read the value. If no matching rule can be found, null will be returned. If more than one row matches, the first found row will be returned.

  The first argument to get row is a where-expression With the conditions the returned row should match.

  The second document is optional and is an object that can modify the search. This is mainly useful in case there is more than one matching row for the where-expression in the first argument and you want to give an explicit order. For example, use `{orderBy: "name"}` as the second argument to pick the first row by the name field, ordered ascending. `{orderBy: "name", orderDesc: true}` to order by name, descending

  This is however rare and usually getRow is run with a single argument of a Where expression that uniquely determines the row to return, if it exisits.

  #### Parameters

  - ##### where: Where = {}

  - ##### selopts: SelectOptions & ForUserRequest = {}

  #### Returns Promise<null | Row>

  #### Example

      const bookTable = Table.findOne({name: "books"})

      // get the row in the book table with id = 5
      const myBook = await bookTable.getRow({id: 5})

      // get the row for the last book published by Leo Tolstoy
      const myBook = await bookTable.getRow({author: "Leo Tolstoy"}, {orderBy: "published", orderDesc: true})

  - Defined in saltcorn-data/models/table.ts:1144

### getRows

- getRows(where?, selopts?): Promise<Row[]>

- Get all matching rows from the table in the database.

  The arguments are the same as for getRow. The first argument is where-expression with the conditions to match, and the second argument is an optional object and allows you to set ordering and limit options. Keywords that can be used in the second argument are orderBy, orderDesc, limit and offset.

  getRows will return an array of rows matching the where-expression in the first argument, wrapped in a Promise (use await to read the array).

  #### Parameters

  - ##### where: Where = {}

  - ##### selopts: SelectOptions & ForUserRequest = {}

  #### Returns Promise<Row[]>

  #### Example

      const bookTable = Table.findOne({name: "books"})

      // get the rows in the book table with author = "Henrik Pontoppidan"
      const myBooks = await bookTable.getRows({author: "Henrik Pontoppidan"})

      // get the 3 most recent books written by "Henrik Pontoppidan" with more than 500 pages
      const myBooks = await bookTable.getRows({author: "Henrik Pontoppidan", pages: {gt: 500}}, {orderBy: "published", orderDesc: true})

  - Defined in saltcorn-data/models/table.ts:1202

### getTags

- getTags(): Promise<AbstractTag[]>

- #### Returns Promise<AbstractTag[]>

  Implementation of AbstractTable.getTags

  - Defined in saltcorn-data/models/table.ts:4115

### get_child_relations

- get_child_relations(allow_join_aggregations?): Promise<ChildRelations>

- Get child relations for table

  #### Parameters

  - ##### `Optional` allow_join_aggregations: boolean

  #### Returns Promise<ChildRelations>

  - Defined in saltcorn-data/models/table.ts:3590

### get_history

- get_history(id?): Promise<Row[]>

- Get table history data

  #### Parameters

  - ##### `Optional` id: PrimaryKeyValue

  #### Returns Promise<Row[]>

  - Defined in saltcorn-data/models/table.ts:2734

### get_join_field_options

- get_join_field_options(allow_double?, allow_triple?): Promise<JoinFieldOption[]>

- get join-field-options joined from a field in this table

  #### Parameters

  - ##### `Optional` allow_double: boolean

  - ##### `Optional` allow_triple: boolean

  #### Returns Promise<JoinFieldOption[]>

  - Defined in saltcorn-data/models/table.ts:3363

### get_models

- get_models(where?): Promise<any>

- Get Models tbd why this function in this file - needs to models

  #### Parameters

  - ##### `Optional` where: string | Where

  #### Returns Promise<any>

  - Defined in saltcorn-data/models/table.ts:476

### get_parent_relations

- get_parent_relations(allow_double?, allow_triple?): Promise<ParentRelations>

- Get parent relations for table

  #### Parameters

  - ##### `Optional` allow_double: boolean

  - ##### `Optional` allow_triple: boolean

  #### Returns Promise<ParentRelations>

  - Defined in saltcorn-data/models/table.ts:3480

### get_relation_data

- get_relation_data(unique?): Promise<RelationData[]>

- get relation-data joined from a field of another table

  #### Parameters

  - ##### unique: boolean = true

  #### Returns Promise<RelationData[]>

  - Defined in saltcorn-data/models/table.ts:3458

### get_relation_options

- get_relation_options(): Promise<RelationOption[]>

- get relation-options joined from a field of another table

  #### Returns Promise<RelationOption[]>

  - Defined in saltcorn-data/models/table.ts:3439

### import_csv_file

- import_csv_file(filePath, options?): Promise<ResultMessage>

- Import CSV file to existing table

  #### Parameters

  - ##### filePath: string

  - ##### `Optional` options: {
    method?: "Auto" | "copy" | "row-by-row";
    no_table_write?: boolean;
    recalc_stored?: boolean;
    skip_first_data_row?: boolean;
    }

    - ##### `Optional` method?: "Auto" | "copy" | "row-by-row"

    - ##### `Optional` no_table_write?: boolean

    - ##### `Optional` recalc_stored?: boolean

    - ##### `Optional` skip_first_data_row?: boolean

  #### Returns Promise<ResultMessage>

  - Defined in saltcorn-data/models/table.ts:2938

### import_json_file

- import_json_file(filePath, skip_first_data_row?): Promise<ResultMessage>

- Import JSON table description

  #### Parameters

  - ##### filePath: string

  - ##### `Optional` skip_first_data_row: boolean

  #### Returns Promise<ResultMessage>

  - Defined in saltcorn-data/models/table.ts:3300

### import_json_history_file

- import_json_history_file(filePath): Promise<void>

- #### Parameters

  - ##### filePath: string

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:3288

### insertRow

- insertRow(v_in0, user?, resultCollector?, noTrigger?, syncTimestamp?): Promise<any>

- Insert row into the table. By passing in the user as the second argument, it will check write rights. If a user object is not supplied, the insert goes ahead without checking write permissions.

  Returns the primary key value of the inserted row.

  This will throw an exception if the row does not conform to the table constraints. If you would like to insert a row with a function that can return an error message, use tryInsertRow instead.

  #### Parameters

  - ##### v_in0: Row

  - ##### `Optional` user: AbstractUser

  - ##### `Optional` resultCollector: object

  - ##### `Optional` noTrigger: boolean

  - ##### `Optional` syncTimestamp: Date

  #### Returns Promise<any>

  #### Example

      await Table.findOne("People").insertRow({ name: "Jim", age: 35 })

  - Defined in saltcorn-data/models/table.ts:1916

### insert_history_row

- insert_history_row(v0, retry?): Promise<void>

- #### Parameters

  - ##### v0: Row

  - ##### retry: number = 0

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:1682

### is_owner

- is_owner(user, row): boolean

- Check if user is owner of row

  #### Parameters

  - ##### user: undefined | AbstractUser

    user

  - ##### row: Row

    table row

  #### Returns boolean

  - Defined in saltcorn-data/models/table.ts:510

### latestSyncInfo

- latestSyncInfo(id): Promise<any>

- #### Parameters

  - ##### id: PrimaryKeyValue

  #### Returns Promise<any>

  - Defined in saltcorn-data/models/table.ts:1703

### latestSyncInfos

- latestSyncInfos(ids): Promise<any>

- #### Parameters

  - ##### ids: PrimaryKeyValue[]

  #### Returns Promise<any>

  - Defined in saltcorn-data/models/table.ts:1708

### move_include_fts_to_search_context

- move_include_fts_to_search_context(): Promise<void>

- #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:4200

### normalise_error_message

- normalise_error_message(msg): string

- #### Parameters

  - ##### msg: string

  #### Returns string

  - Defined in saltcorn-data/models/table.ts:2324

### normalise_fkey_values

- normalise_fkey_values(v_in): void

- #### Parameters

  - ##### v_in: Row

  #### Returns void

  - Defined in saltcorn-data/models/table.ts:1882

### owner_fieldname

- owner_fieldname(): null | string

- Get owner column name

  #### Returns null | string

  - Defined in saltcorn-data/models/table.ts:498

### owner_fieldname_from_fields

- owner_fieldname_from_fields(fields?): null | string

- Get owner column name

  #### Parameters

  - ##### `Optional` fields: null | Field[]

    fields list

  #### Returns null | string

  null or owner column name

  - Defined in saltcorn-data/models/table.ts:488

### ownership_formula_where

- ownership_formula_where(user): Where

- #### Parameters

  - ##### user: AbstractUser

  #### Returns Where

  - Defined in saltcorn-data/models/table.ts:3719

### ownership_options

- ownership_options(): Promise<{
  label: string;
  value: string;
  }[]>

- get Ownership options user interface...

  #### Returns Promise<{
  label: string;
  value: string;
  }[]>

  - Defined in saltcorn-data/models/table.ts:533

### parse_json_fields

- parse_json_fields(v1): Row

- #### Parameters

  - ##### v1: Row

  #### Returns Row

  - Defined in saltcorn-data/models/table.ts:3275

### processSelectOptions

- processSelectOptions(selopts?): SelectOptions & ForUserRequest

- #### Parameters

  - ##### selopts: SelectOptions & ForUserRequest = {}

  #### Returns SelectOptions & ForUserRequest

  - Defined in saltcorn-data/models/table.ts:1244

### read_state_strict

- read_state_strict(state): string | Row

- #### Parameters

  - ##### state: Row

  #### Returns string | Row

  - Defined in saltcorn-data/models/table.ts:2877

### redo_row_changes

- redo_row_changes(id, user?): Promise<void>

- Redo row changes

  #### Parameters

  - ##### id: PrimaryKeyValue

  - ##### `Optional` user: AbstractUser

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:2563

### rename

- rename(new_name): Promise<void>

- Rename table

  #### Parameters

  - ##### new_name: string

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:2658

### repairCompositePrimary

- repairCompositePrimary(): Promise<void>

- #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:4142

### resetSequence

- resetSequence(): Promise<void>

- Reset Sequence

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:868

### restore_row_version

- restore_row_version(id, version, user?): Promise<void>

- Restore Row Version

  #### Parameters

  - ##### id: PrimaryKeyValue

  - ##### version: number

  - ##### `Optional` user: AbstractUser

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:2508

### slug_options

- slug_options(): Promise<{
  label: string;
  steps: SlugStepType[];
  }[]>

- #### Returns Promise<{
  label: string;
  steps: SlugStepType[];
  }[]>

  - Defined in saltcorn-data/models/table.ts:4067

### stringify_json_fields

- stringify_json_fields(v1): void

- #### Parameters

  - ##### v1: Row

  #### Returns void

  - Defined in saltcorn-data/models/table.ts:3266

### to_provided_table

- to_provided_table(): any

- #### Returns any

  - Defined in saltcorn-data/models/table.ts:305

### toggleBool

- toggleBool(id, field_name, user?): Promise<void>

- ????

  #### Parameters

  - ##### id: PrimaryKeyValue

  - ##### field_name: string

  - ##### `Optional` user: AbstractUser

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:1805

### tryInsertRow

- tryInsertRow(v, user?, resultCollector?): Promise<{
  error: string;
  } | {
  success: PrimaryKeyValue;
  }>

- Try to Insert row

  #### Parameters

  - ##### v: Row

  - ##### `Optional` user: AbstractUser

  - ##### `Optional` resultCollector: object

  #### Returns Promise<{
  error: string;
  } | {
  success: PrimaryKeyValue;
  }>

  - Defined in saltcorn-data/models/table.ts:2303

### tryUpdateRow

- tryUpdateRow(v, id, user?, resultCollector?): Promise<ResultMessage>

- Try to Update row

  #### Parameters

  - ##### v: Row

  - ##### id: PrimaryKeyValue

  - ##### `Optional` user: AbstractUser

  - ##### `Optional` resultCollector: object

  #### Returns Promise<ResultMessage>

  - Defined in saltcorn-data/models/table.ts:1778

### undo_row_changes

- undo_row_changes(id, user?): Promise<void>

- Undo row chnages

  #### Parameters

  - ##### id: PrimaryKeyValue

  - ##### `Optional` user: AbstractUser

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:2531

### update

- update(new_table_rec): Promise<void>

- Update Table description in _sc_table Also creates / drops history table for table

  #### Parameters

  - ##### new_table_rec: Partial<Table>

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:2695

### updateRow

- updateRow(v_in, id, user?, noTrigger?, resultCollector?, restore_of_version?, syncTimestamp?, additionalTriggerValues?, autoRecalcIterations?): Promise<string | void>

- Update a single row in the table database.

  The first two arguments are mandatory. The first is an object with the new values to set in the row. The second argument is the value of the primary key of the row to update. Typically this is the id field of an existing row object

  #### Parameters

  - ##### v_in: Row

    columns with values to update

  - ##### id: PrimaryKeyValue

    id value

  - ##### `Optional` user: AbstractUser

  - ##### `Optional` noTrigger: boolean | {
    additionalTriggerValues?: Row;
    autoRecalcIterations?: number;
    noTrigger?: boolean;
    restore_of_version?: number;
    resultCollector?: object;
    syncTimestamp?: Date;
    }

  - ##### `Optional` resultCollector: object

  - ##### `Optional` restore_of_version: number

  - ##### `Optional` syncTimestamp: Date

  - ##### `Optional` additionalTriggerValues: Row

  - ##### `Optional` autoRecalcIterations: number

  #### Returns Promise<string | void>

  #### Example

      const bookTable = Table.findOne({name: "books"})

      // get the row in the book table for Moby Dick
      const moby_dick = await bookTable.getRow({title: "Moby Dick"})

      // Update the read field to true and the rating field to 5
      await bookTable.updateRow({read: true, rating: 5}, moby_dick.id)

      // if you want to update more than one row, you must first retrieve all the rows and
      // then update them individually

      const allBooks = await bookTable.getRows()
      for(const book of allBooks) {
        await bookTable.updateRow({price: book.price*0.8}, book.id)
      }

  - Defined in saltcorn-data/models/table.ts:1357

### `Static` allSlugOptions

- allSlugOptions(): Promise<{
  [nm: string]: {
  label: string;
  steps: SlugStepType[];
  }[];
  }>

- #### Returns Promise<{
  [nm: string]: {
  label: string;
  steps: SlugStepType[];
  }[];
  }>

  - Defined in saltcorn-data/models/table.ts:4099

### `Static` create

- create(name, options?, id?): Promise<Table>

- Create table

  #### Parameters

  - ##### name: string

    table name

  - ##### options: SelectOptions | TablePack = {}

    table fields

  - ##### `Optional` id: number

    optional id, if set, no '_sc_tables' entry is inserted

  #### Returns Promise<Table>

  table

  - Defined in saltcorn-data/models/table.ts:707

### `Static` createInDb

- createInDb(table): Promise<void>

- Create the table structure generates a CREATE TABLE cmd with all field and runs it TODO field defaults for pg

  #### Parameters

  - ##### table: Table

  #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:790

### `Static` create_from_csv

- create_from_csv(name, filePath): Promise<ResultMessage>

- Table Create from CSV

  #### Parameters

  - ##### name: string

  - ##### filePath: string

  #### Returns Promise<ResultMessage>

  - Defined in saltcorn-data/models/table.ts:2757

### `Static` find

- find(where?, selectopts?): Promise<Table[]>

- Find Tables

  #### Parameters

  - ##### `Optional` where: Where

    where condition

  - ##### selectopts: SelectOptions = ...

    options

  #### Returns Promise<Table[]>

  table list

  - Defined in saltcorn-data/models/table.ts:382

### `Static` findOne

- findOne(where): null | Table

- Find one Table

  #### Parameters

  - ##### where: string | number | Where | Table

    where condition

  #### Returns null | Table

  table or null

  - Defined in saltcorn-data/models/table.ts:343

### `Static` find_with_external

- find_with_external(where0?, selectopts?): Promise<Table[]>

- Find Tables including external tables

  #### Parameters

  - ##### where0: Where = {}

  - ##### selectopts: SelectOptions = ...

  #### Returns Promise<Table[]>

  - Defined in saltcorn-data/models/table.ts:438

### `Static` state_refresh

- state_refresh(): Promise<void>

- #### Returns Promise<void>

  - Defined in saltcorn-data/models/table.ts:2725

Generated using TypeDoc